CFPRIME INTINJ                                                          INTINJ      1
C***********************************************************************RIGHTE      1
C*                                                                     *RIGHTE      2
C*        Extended Transient-Midterm Stability Program (ETMSP)         *RIGHTE      3
C*        ====================================================         *RIGHTE      4
C*                                                                     *RIGHTE      5
C*       Copyright (C) (1993) Electric Power Research Institute        *RIGHTE      6
C*                                                                     *RIGHTE      7
C* EPRI reserves all rights in the software and associated             *RIGHTE      8
C* documentation as delivered. The software and its associated         *RIGHTE      9
C* documention or any portion thereof may not be reproduced in any form*RIGHTE     10
C* whatsoever without the consent of EPRI, except as explicity provided*RIGHTE     11
C* for by license. Licensee shall submit a detailed description to EPRI*RIGHTE     12
C* of any changes or modifications to the software within two (2)      *RIGHTE     13
C* months after such changes or modifications are made. At EPRI's sole *RIGHTE     14
C* discretion, the software, as changed or modified, shall be given a  *RIGHTE     15
C* new designation sufficiently different from its then current        *RIGHTE     16
C* designation as to prevent mistake,confusion, or deception as between*RIGHTE     17
C* the current software as changed or modified.                        *RIGHTE     18
C*                                                                     *RIGHTE     19
C* A license under EPRI's rights in the software can be obtained       *RIGHTE     20
C* directly from EPRI.                                                 *RIGHTE     21
C*                                                                     *RIGHTE     22
C* This program and supporting materials may be independently available*RIGHTE     23
C* from Electric Power Software centre (EPSC) for an appropriate       *RIGHTE     24
C* distribution fee. The EPSC is a service of                          *RIGHTE     25
C*                                                                     *RIGHTE     26
C*                    Power Computing Company                          *RIGHTE     27
C*                    1930 Hi Line                                     *RIGHTE     28
C*                    Dallas, Tx 75207                                 *RIGHTE     29
C*                                                                     *RIGHTE     30
C* NEITHER EPRI, ANY MEMBER OF EPRI, NOR ANY PERSON OR  ORGANIZATION   *RIGHTE     31
C* ACTING ON BEHAVE OF THEM:                                           *RIGHTE     32
C*                                                                     *RIGHTE     33
C* 1. MAKE ANY WARRANTY OR REPRESENTATION WHATSOEVER, EXPRESS OR       *RIGHTE     34
C*    IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR FITNESS OR *RIGHTE     35
C*    ANY PURPOSE WITH RESPECT TO THE SOFTWARE OR ITS ASSOCIATED       *RIGHTE     36
C*    DOCUMENTATION; OR                                                *RIGHTE     37
C*                                                                     *RIGHTE     38
C* 2. ASSUMES ANY LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE  *RIGHTE     39
C*    SOFTWARE OR ITS ASSOCIATED DOCUMENTATION OR ANY PORTION THEREOF  *RIGHTE     40
C*    OR WITH RESPECT TO ANY DAMAGES WHICH MAY RESULT FROM SUCH USE.   *RIGHTE     41
C*                                                                     *RIGHTE     42
C* THIS NOTICE MAY NOT BE REMOVED FROM THE SOFTWARE BY ANY USER        *RIGHTE     43
C* THEREOF.                                                            *RIGHTE     44
C*                                                                     *RIGHTE     45
C***********************************************************************RIGHTE     46
      SUBROUTINE  INTINJ                                                INTINJ      3
CD -------------------------------------------------------------------  INTINJ      4
CD                                                                      INTINJ      5
CD              *****     INTINJ  ROUTINE   *****                       INTINJ      6
CD                                                                      INTINJ      7
CD -------------------------------------------------------------------  INTINJ      8
CD                                                                      INTINJ      9
CD       PURPOSE:  Calculates total current injection at each           INTINJ     10
CD                 converter ac bus, from all converters on bus.        INTINJ     11
CD                 to initialize history terms for Thevenin calculation INTINJ     12
CD                                                                      INTINJ     13
CD                                                                      INTINJ     14
CD       DEFINITION OF LOCAL VARIABLES:                                 INTINJ     15
CD                 K      - 'do' loop index.                            INTINJ     16
CD                 NUM    -  pointer to location of voltage in dCD      INTINJ     17
CD                           arrays from converter reference.           INTINJ     18
CD                 PA     -  component of real current injection.       INTINJ     19
CD                 PB     -  component of real current injection.       INTINJ     20
CD                 JPOSN   -  storage position for dc information.      INTINJ     21
CD                 QA     -  component of imaginary current injection.  INTINJ     22
CD                 QB     -  component of imaginary current injection.  INTINJ     23
CD                 VALUE  -  square of voltage magnitude.               INTINJ     24
CD                                                                      INTINJ     25
CD -------------------------------------------------------------------  INTINJ     26
      INCLUDE 'PARX.INS'                                                INTINJ     27
      INCLUDE 'CNPT.INS'                                                INTINJ     28
      INCLUDE 'GRDC01.INS'                                              INTINJ     29
      INCLUDE 'GRDC02.INS'                                              INTINJ     30
      INCLUDE 'GRDC03.INS'                                              INTINJ     31
      INCLUDE 'UDCF.INS'                                                INTINJ     32
C                                                                       INTINJ     33
C---------------------------------------------------------------------  INTINJ     34
C                                                                       INTINJ     35
C                                                                       INTINJ     36
      DO 20 NUM = 1, NACBUS                                             INTINJ     37
         PHISDC(NUM) = 0.0                                              INTINJ     38
         QHISDC(NUM) = 0.0                                              INTINJ     39
20    CONTINUE                                                          INTINJ     40
C                                                                       INTINJ     41
C     For each line commutated dc converter, add the current injection  INTINJ     42
C     to the corresponding ac bus.                                      INTINJ     43
C                                                                       INTINJ     44
      DO 40 K = 1, LCDC                                                 INTINJ     45
         IF(IDC(K) .NE. 0)THEN                                          INTINJ     46
            JPOSN = IDC(K)                                              INTINJ     47
            NUM = IDCBNU(JPOSN)                                         INTINJ     48
            IF(NUM .EQ. 0) GO TO 40                                     INTINJ     49
            VALUE = DCEA(NUM) * DCEA(NUM) + DCEB(NUM) * DCEB(NUM)       INTINJ     50
            IF(VALUE.LE.0.0.AND.VALUE.GE.0.0) VALUE = 0.01              INTINJ     51
            PA = DCEA(NUM) * PAHVDC(JPOSN) / PABASE                     INTINJ     52
            QA = DCEA(NUM) * QAHVDC(JPOSN) / PABASE                     INTINJ     53
            PB = DCEB(NUM) * QAHVDC(JPOSN) / PABASE                     INTINJ     54
            QB = DCEB(NUM) * PAHVDC(JPOSN) / PABASE                     INTINJ     55
            PINJDC(JPOSN) = (PA + PB) / VALUE                           INTINJ     56
            QINJDC(JPOSN) = (QB - QA) / VALUE                           INTINJ     57
            PHISDC(NUM) = PHISDC(NUM) + PINJDC(JPOSN)                   INTINJ     58
            QHISDC(NUM) = QHISDC(NUM) + QINJDC(JPOSN)                   INTINJ     59
         END IF                                                         INTINJ     60
40    CONTINUE                                                          INTINJ     61
C                                                                       INTINJ     62
C                                                                       INTINJ     63
C                                                                       INTINJ     64
C---------------------------------------------------------------------  INTINJ     65
C                                                                       INTINJ     66
      RETURN                                                            INTINJ     67
C                                                                       INTINJ     68
C---------------------------------------------------------------------  INTINJ     69
C                                                                       INTINJ     70
      END                                                               INTINJ     71
